<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "crawler_provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CrawlerProvider".
 *
 * Columns in table "crawler_provider" available as properties of the model,
 * followed by relations of table "crawler_provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $crawler_id
 * @property integer $provider_id
 * @property string $npi
 * @property string $gender
 * @property string $first_name
 * @property string $middle_name
 * @property string $last_name
 * @property string $credential
 * @property string $profile_url
 * @property string $in_person_book_app_url
 * @property string $teleheath_book_app_url
 * @property string $req_app_url
 * @property string $date_added
 * @property string $date_updated
 *
 * @property Crawler $crawler
 * @property Provider $provider
 * @property CrawlerProviderPhoto[] $crawlerProviderPhotos
 * @property CrawlerProviderPractice[] $crawlerProviderPractices
 * @property CrawlerProviderSpecialty[] $crawlerProviderSpecialties
 */
abstract class BaseCrawlerProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'crawler_provider';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CrawlerProvider|CrawlerProviders', $n);
    }

    public static function representingColumn()
    {
        return 'profile_url';
    }

    public function rules()
    {
        return array(
            array('crawler_id, profile_url, date_added', 'required'),
            array('crawler_id, provider_id', 'numerical', 'integerOnly' => true),
            array('npi', 'length', 'max' => 10),
            array('gender', 'length', 'max' => 5),
            array('first_name, middle_name, credential', 'length', 'max' => 50),
            array('last_name', 'length', 'max' => 80),
            array('profile_url, in_person_book_app_url, teleheath_book_app_url, req_app_url', 'length', 'max' => 255),
            array('date_updated', 'safe'),
            array(
                'provider_id, npi, gender, first_name, middle_name, last_name, credential, in_person_book_app_url,
                    teleheath_book_app_url, req_app_url, date_updated',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, crawler_id, provider_id, npi, gender, first_name, middle_name, last_name, credential,
                    profile_url, in_person_book_app_url, teleheath_book_app_url, req_app_url, date_added, date_updated',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'crawler' => array(self::BELONGS_TO, 'Crawler', 'crawler_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'crawlerProviderPhotos' => array(self::HAS_MANY, 'CrawlerProviderPhoto', 'crawler_provider_id'),
            'crawlerProviderPractices' => array(self::HAS_MANY, 'CrawlerProviderPractice', 'crawler_provider_id'),
            'crawlerProviderSpecialties' => array(self::HAS_MANY, 'CrawlerProviderSpecialty', 'crawler_provider_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'crawler_id' => null,
            'provider_id' => null,
            'npi' => Yii::t('app', 'Npi'),
            'gender' => Yii::t('app', 'Gender'),
            'first_name' => Yii::t('app', 'First Name'),
            'middle_name' => Yii::t('app', 'Middle Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'credential' => Yii::t('app', 'Credential'),
            'profile_url' => Yii::t('app', 'Profile Url'),
            'in_person_book_app_url' => Yii::t('app', 'In Person Book App Url'),
            'teleheath_book_app_url' => Yii::t('app', 'Teleheath Book App Url'),
            'req_app_url' => Yii::t('app', 'Req App Url'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'crawler' => null,
            'provider' => null,
            'crawlerProviderPhotos' => null,
            'crawlerProviderPractices' => null,
            'crawlerProviderSpecialties' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('crawler_id', $this->crawler_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('npi', $this->npi, true);
        $criteria->compare('gender', $this->gender, true);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('middle_name', $this->middle_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('credential', $this->credential, true);
        $criteria->compare('profile_url', $this->profile_url, true);
        $criteria->compare('in_person_book_app_url', $this->in_person_book_app_url, true);
        $criteria->compare('teleheath_book_app_url', $this->teleheath_book_app_url, true);
        $criteria->compare('req_app_url', $this->req_app_url, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
